@prefix dct:      <http://purl.org/dc/elements/1.1/> .
@prefix flint:    <http://ontology.tno.nl/normengineering/flint/model/def/> .
@prefix act:      <http://ontology.tno.nl/normengineering/flint/actframe/model/def/> .
@prefix fact:     <http://ontology.tno.nl/normengineering/flint/factframe/model/def/> .
@prefix map:      <http://ontology.tno.nl/normengineering/flint/mapping/> .
@prefix owl:      <http://www.w3.org/2002/07/owl#> .
@prefix prov:     <http://www.w3.org/ns/prov#> .
@prefix rdf:      <http://www.w3.org/1999/02/22-rdf-syntax-ns#> .
@prefix rdfs:     <http://www.w3.org/2000/01/rdf-schema#> .
@prefix scenario: <http://ontology.tno.nl/normengineering/flint/scenario/id/> .
@prefix sh:       <http://www.w3.org/ns/shacl#> .
@prefix shp:      <http://ontology.tno.nl/normengineering/flint/model/shp/> .
@prefix xml:      <http://www.w3.org/XML/1998/namespace> .
@prefix xsd:      <http://www.w3.org/2001/XMLSchema#> .

### Fact frame Tic-Tac-Toe
    
fact:Frame_TicTacToe 
   dct:source <https://example.com/tictactoerules/id/text/rule1>;
   rdfs:subClassOf flint:FactFrame;
   owl:intersectionOf (
       
	[rdf:type owl:Restriction;
	owl:onProperty fact:gameStatus;
	owl:onClass fact:GameStatus;
	owl:qualifiedCardinality "1"^^xsd:nonNegativeInteger
	]
   
   [rdf:type owl:Restriction;
	owl:onProperty fact:gameWinner;
	owl:onClass fact:GameWinner;
	owl:qualifiedCardinality "1"^^xsd:nonNegativeInteger
	]
   
   [rdf:type owl:Restriction;
	owl:onProperty fact:isPlayedOn;
	owl:onClass fact:GameBoard;
	owl:qualifiedCardinality "1"^^xsd:nonNegativeInteger
	]
	
   [rdf:type owl:Restriction;
	owl:onProperty fact:isPlayedBy;
	owl:onClass fact:Player;
	owl:qualifiedCardinality "2"^^xsd:nonNegativeInteger
	]
   
	[rdf:type owl:Restriction;
	owl:onProperty fact:isPlayedBy;
	owl:onClass fact:PlayerX;
	owl:qualifiedCardinality "1"^^xsd:nonNegativeInteger
	]
   
	[rdf:type owl:Restriction;
	owl:onProperty fact:isPlayedBy;
	owl:onClass fact:PlayerO;
	owl:qualifiedCardinality "1"^^xsd:nonNegativeInteger
	]
	
   [rdf:type owl:Restriction;
	owl:onProperty fact:playerTurn;
	owl:onClass fact:PlayerWithTurn;
	owl:qualifiedCardinality "1"^^xsd:nonNegativeInteger
	]
   ) .

### Gameboard

fact:GameBoard rdfs:subClassOf flint:Fact;
	owl:intersectionOf (
	[rdf:type owl:Restriction;
	owl:onProperty fact:hasSquare;
	owl:onClass fact:Square1;
	owl:qualifiedCardinality "1"^^xsd:nonNegativeInteger]
	[rdf:type owl:Restriction;
	owl:onProperty fact:hasSquare;
	owl:onClass fact:Square2;
	owl:qualifiedCardinality "1"^^xsd:nonNegativeInteger]
	[rdf:type owl:Restriction;
	owl:onProperty fact:hasSquare;
	owl:onClass fact:Square3;
	owl:qualifiedCardinality "1"^^xsd:nonNegativeInteger]
	[rdf:type owl:Restriction;
	owl:onProperty fact:hasSquare;
	owl:onClass fact:Square4;
	owl:qualifiedCardinality "1"^^xsd:nonNegativeInteger]
	[rdf:type owl:Restriction;
	owl:onProperty fact:hasSquare;
	owl:onClass fact:Square5;
	owl:qualifiedCardinality "1"^^xsd:nonNegativeInteger]
	[rdf:type owl:Restriction;
	owl:onProperty fact:hasSquare;
	owl:onClass fact:Square6;
	owl:qualifiedCardinality "1"^^xsd:nonNegativeInteger]
	[rdf:type owl:Restriction;
	owl:onProperty fact:hasSquare;
	owl:onClass fact:Square7;
	owl:qualifiedCardinality "1"^^xsd:nonNegativeInteger]
	[rdf:type owl:Restriction;
	owl:onProperty fact:hasSquare;
	owl:onClass fact:Square8;
	owl:qualifiedCardinality "1"^^xsd:nonNegativeInteger]
	[rdf:type owl:Restriction;
	owl:onProperty fact:hasSquare;
	owl:onClass fact:Square9;
	owl:qualifiedCardinality "1"^^xsd:nonNegativeInteger]) .

### Squares of the gameboard

fact:Square rdfs:subClassOf flint:Fact.

fact:Square1 rdfs:subClassOf fact:Square,
	[rdf:type owl:Restriction;
	owl:onProperty fact:squareContent;
	owl:onClass fact:SquareContent;
	owl:qualifiedCardinality "1"^^xsd:nonNegativeInteger] ;
	rdfs:label "square1".

fact:Square2 rdfs:subClassOf fact:Square,
	[rdf:type owl:Restriction;
	owl:onProperty fact:squareContent;
	owl:onClass fact:SquareContent;
	owl:qualifiedCardinality "1"^^xsd:nonNegativeInteger] ;
	rdfs:label "square2".

fact:Square3 rdfs:subClassOf fact:Square,
	[rdf:type owl:Restriction;
	owl:onProperty fact:squareContent;
	owl:onClass fact:SquareContent;
	owl:qualifiedCardinality "1"^^xsd:nonNegativeInteger] ;
	rdfs:label "square3".

fact:Square4 rdfs:subClassOf fact:Square,
	[rdf:type owl:Restriction;
	owl:onProperty fact:squareContent;
	owl:onClass fact:SquareContent;
	owl:qualifiedCardinality "1"^^xsd:nonNegativeInteger] ;
	rdfs:label "square4".

fact:Square5 rdfs:subClassOf fact:Square,
	[rdf:type owl:Restriction;
	owl:onProperty fact:squareContent;
	owl:onClass fact:SquareContent;
	owl:qualifiedCardinality "1"^^xsd:nonNegativeInteger] ;
	rdfs:label "square5".

fact:Square6 rdfs:subClassOf fact:Square,
	[rdf:type owl:Restriction;
	owl:onProperty fact:squareContent;
	owl:onClass fact:SquareContent;
	owl:qualifiedCardinality "1"^^xsd:nonNegativeInteger] ;
	rdfs:label "square6".

fact:Square7 rdfs:subClassOf fact:Square,
	[rdf:type owl:Restriction;
	owl:onProperty fact:squareContent;
	owl:onClass fact:SquareContent;
	owl:qualifiedCardinality "1"^^xsd:nonNegativeInteger] ;
	rdfs:label "square7".

fact:Square8 rdfs:subClassOf fact:Square,
	[rdf:type owl:Restriction;
	owl:onProperty fact:squareContent;
	owl:onClass fact:SquareContent;
	owl:qualifiedCardinality "1"^^xsd:nonNegativeInteger] ;
	rdfs:label "square8".

fact:Square9 rdfs:subClassOf fact:Square,
	[rdf:type owl:Restriction;
	owl:onProperty fact:squareContent;
	owl:onClass fact:SquareContent;
	owl:qualifiedCardinality "1"^^xsd:nonNegativeInteger] ;
	rdfs:label "square9".

fact:EmptySquare rdf:type owl:Class;
  owl:equivalentClass [
    rdf:type owl:Restriction ;
    owl:onProperty fact:squareContent ;
    owl:someValuesFrom fact:Empty
  ].
  
fact:SquareWithContent rdf:type owl:Class;
  owl:equivalentClass [
    rdf:type owl:Restriction ;
    owl:onProperty fact:squareContent ;
    owl:someValuesFrom fact:MarkingSymbol
  ].
 
fact:EmptyGameBoard rdfs:subClassOf fact:GameBoard;
	owl:intersectionOf (
	[rdf:type owl:Restriction;
	owl:onProperty fact:hasSquare;
	owl:someValuesFrom fact:EmptySquare1]
	[rdf:type owl:Restriction;
	owl:onProperty fact:hasSquare;
    owl:someValuesFrom fact:EmptySquare2]
	[rdf:type owl:Restriction;
	owl:onProperty fact:hasSquare;
	owl:someValuesFrom fact:EmptySquare3]
	[rdf:type owl:Restriction;
	owl:onProperty fact:hasSquare;
	owl:someValuesFrom fact:EmptySquare4]
	[rdf:type owl:Restriction;
	owl:onProperty fact:hasSquare;
	owl:someValuesFrom fact:EmptySquare5]
	[rdf:type owl:Restriction;
	owl:onProperty fact:hasSquare;
	owl:someValuesFrom fact:EmptySquare6]
	[rdf:type owl:Restriction;
	owl:onProperty fact:hasSquare;
	owl:someValuesFrom fact:EmptySquare7]
	[rdf:type owl:Restriction;
	owl:onProperty fact:hasSquare;
	owl:someValuesFrom fact:EmptySquare8]
	[rdf:type owl:Restriction;
	owl:onProperty fact:hasSquare;
	owl:someValuesFrom fact:EmptySquare9]).

fact:GameBoardWithContent owl:intersectionOf (fact:GameBoard
	[rdf:type owl:Restriction;
	owl:onProperty fact:hasSquare;
	owl:someValuesFrom fact:SquareWithContent]).

fact:EmptySquare1 owl:intersectionOf (fact:Square1 
	[rdf:type owl:Restriction;
	owl:onProperty fact:squareContent;
	owl:someValuesFrom fact:Empty]).

fact:EmptySquare2 owl:intersectionOf (fact:Square2
	[rdf:type owl:Restriction;
	owl:onProperty fact:squareContent;
    owl:someValuesFrom fact:Empty]).

fact:EmptySquare3 owl:intersectionOf ( fact:Square3
	[rdf:type owl:Restriction;
	owl:onProperty fact:squareContent;
    owl:someValuesFrom fact:Empty]).

fact:EmptySquare4 owl:intersectionOf ( fact:Square4
	[rdf:type owl:Restriction;
	owl:onProperty fact:squareContent;
    owl:someValuesFrom fact:Empty]).

fact:EmptySquare5 owl:intersectionOf ( fact:Square5
	[rdf:type owl:Restriction;
	owl:onProperty fact:squareContent;
    owl:someValuesFrom fact:Empty]).

fact:EmptySquare6 owl:intersectionOf ( fact:Square6
	[rdf:type owl:Restriction;
	owl:onProperty fact:squareContent;
    owl:someValuesFrom fact:Empty]).

fact:EmptySquare7 owl:intersectionOf ( fact:Square7
	[rdf:type owl:Restriction;
	owl:onProperty fact:squareContent;
    owl:someValuesFrom fact:Empty]).

fact:EmptySquare8 owl:intersectionOf ( fact:Square8
	[rdf:type owl:Restriction;
	owl:onProperty fact:squareContent;
    owl:someValuesFrom fact:Empty]).

fact:EmptySquare9 owl:intersectionOf ( fact:Square9
	[rdf:type owl:Restriction;
	owl:onProperty fact:squareContent;
    owl:someValuesFrom fact:Empty]).


### Square Content

fact:SymbolX rdfs:subClassOf fact:MarkingSymbol;
             rdfs:label "symbol X".
fact:SymbolO rdfs:subClassOf fact:MarkingSymbol;
             rdfs:label "symbol O".
fact:MarkingSymbol rdfs:subClassOf fact:SquareContent.
fact:Empty rdfs:subClassOf fact:SquareContent;
           rdfs:label "empty".
fact:SquareContent rdfs:subClassOf flint:Fact;
		 owl:unionOf (fact:SymbolX fact:SymbolO fact:Empty).

fact:Square1Symbol owl:intersectionOf (
    fact:MarkingSymbol
    [ rdf:type owl:Restriction ;
      owl:onProperty [owl:inverseOf fact:squareContent] ;
      owl:someValuesFrom fact:Square1
    ]
  )
.

fact:Square2Symbol owl:intersectionOf (
    fact:MarkingSymbol
    [ rdf:type owl:Restriction ;
      owl:onProperty [owl:inverseOf fact:squareContent] ;
      owl:someValuesFrom fact:Square2
    ]
  )
.

fact:Square3Symbol owl:intersectionOf (
    fact:MarkingSymbol
    [ rdf:type owl:Restriction ;
      owl:onProperty [owl:inverseOf fact:squareContent] ;
      owl:someValuesFrom fact:Square3
    ]
  )
.

fact:Square4Symbol owl:intersectionOf (
    fact:MarkingSymbol
    [ rdf:type owl:Restriction ;
      owl:onProperty [owl:inverseOf fact:squareContent] ;
      owl:someValuesFrom fact:Square4
    ]
  )
.

fact:Square5Symbol owl:intersectionOf (
    fact:MarkingSymbol
    [ rdf:type owl:Restriction ;
      owl:onProperty [owl:inverseOf fact:squareContent] ;
      owl:someValuesFrom fact:Square5
    ]
  )
.

fact:Square6Symbol owl:intersectionOf (
    fact:MarkingSymbol
    [ rdf:type owl:Restriction ;
      owl:onProperty [owl:inverseOf fact:squareContent] ;
      owl:someValuesFrom fact:Square6
    ]
  )
.

fact:Square7Symbol owl:intersectionOf (
    fact:MarkingSymbol
    [ rdf:type owl:Restriction ;
      owl:onProperty [owl:inverseOf fact:squareContent] ;
      owl:someValuesFrom fact:Square7
    ]
  )
.

fact:Square8Symbol owl:intersectionOf (
    fact:MarkingSymbol
    [ rdf:type owl:Restriction ;
      owl:onProperty [owl:inverseOf fact:squareContent] ;
      owl:someValuesFrom fact:Square8
    ]
  )
.

fact:Square9Symbol owl:intersectionOf (
    fact:MarkingSymbol
    [ rdf:type owl:Restriction ;
      owl:onProperty [owl:inverseOf fact:squareContent] ;
      owl:someValuesFrom fact:Square9
    ]
  )
.

fact:SymbolWithThreeInARow rdfs:subClassOf fact:MarkingSymbol ;
  owl:unionOf (
    [owl:intersectionOf (fact:Square1Symbol fact:Square2Symbol fact:Square3Symbol)] #Top row
    [owl:intersectionOf (fact:Square4Symbol fact:Square5Symbol fact:Square6Symbol)] #Middle row
    [owl:intersectionOf (fact:Square7Symbol fact:Square8Symbol fact:Square9Symbol)] #Bottom row
    [owl:intersectionOf (fact:Square1Symbol fact:Square4Symbol fact:Square7Symbol)] #Left column
    [owl:intersectionOf (fact:Square2Symbol fact:Square5Symbol fact:Square8Symbol)] #Middle column
    [owl:intersectionOf (fact:Square3Symbol fact:Square6Symbol fact:Square9Symbol)] #Right column
    [owl:intersectionOf (fact:Square1Symbol fact:Square5Symbol fact:Square9Symbol)] #Top left to bottom right
    [owl:intersectionOf (fact:Square3Symbol fact:Square5Symbol fact:Square7Symbol)] #Top right to bottom left
  ) ;
.


### Game status and winner

fact:GameStatus rdfs:subClassOf flint:Fact;
		 owl:unionOf (fact:ToBeStarted fact:Running fact:GameOver).
fact:GameWinner rdfs:subClassOf flint:Fact,
	[rdf:type owl:Restriction ;
        owl:onProperty fact:hasWon ;
        owl:someValuesFrom [owl:unionOf (fact:Player fact:NoPlayer fact:ToBeEstablished)]].      

### Players

fact:Player rdfs:subClassOf flint:Fact;
	 owl:unionOf (fact:PlayerX fact:PlayerO);
	      dct:source <https://example.com/tictactoerules/id/text/rule2>, <https://example.com/tictactoerules/id/text/rule3>, <https://example.com/tictactoerules/id/text/rule5>.

fact:PlayerX owl:intersectionOf (
    fact:Player
    [rdf:type owl:Restriction ;
        owl:onProperty fact:opponentOf ;
        owl:someValuesFrom fact:PlayerO]
    [rdf:type owl:Restriction ;
        owl:onProperty fact:playsWithSymbol ;
        owl:someValuesFrom fact:SymbolX]
    );
    owl:disjointWith fact:PlayerO;
	    dct:source <https://example.com/tictactoerules/id/text/rule4>.
        
fact:PlayerO owl:intersectionOf (
    fact:Player
    [rdf:type owl:Restriction ;
        owl:onProperty fact:opponentOf ;
        owl:someValuesFrom fact:PlayerX]
    [rdf:type owl:Restriction ;
        owl:onProperty fact:playsWithSymbol ;
        owl:someValuesFrom fact:SymbolO]
    );
    owl:disjointWith fact:PlayerX;
	dct:source <https://example.com/tictactoerules/id/text/rule6>.
  
fact:Opponent rdfs:subClassOf flint:Fact;
	 owl:unionOf (fact:PlayerX fact:PlayerO).  

fact:PlayerWithTurn rdfs:subClassOf flint:Fact;
 owl:intersectionOf (
    fact:Player 
    [rdf:type owl:Restriction ;
        owl:onProperty [owl:inverseOf flint:actor] ;
        owl:someValuesFrom flint:Act]
	 [rdf:type owl:Restriction ;
        owl:onProperty [owl:inverseOf fact:playerTurn] ;
        owl:someValuesFrom flint:FactFrame]
    ).
    
fact:PlayerWithThreeInARow rdfs:subClassOf fact:Player ;
  owl:equivalentClass [ rdf:type owl:Restriction ;
    owl:onProperty fact:playsWithSymbol ;
    owl:someValuesFrom fact:SymbolWithThreeInARow 
  ]
.

fact:NoPlayer rdfs:subClassOf flint:Fact.

# Actions
  
fact:PuttingMarkInSquare rdfs:subClassOf flint:Fact.
fact:DeclaringAnOutcomeInAGameOfTicTacToe rdfs:subClassOf flint:Fact.

# Objects

fact:Tie rdfs:subClassOf flint:Fact.
fact:Win rdfs:subClassOf flint:Fact.
fact:Foulplay rdfs:subClassOf flint:Fact.

### Fact properties

fact:gameStatus rdfs:subPropertyOf flint:fact;
  rdfs:label "game status" ;  
  rdfs:comment "Connects the fact frame of Tic-Tac-Toe with the game status" ;
  rdfs:domain fact:Frame_TicTacToe ;
  rdfs:range fact:Status.
  
fact:gameWinner rdfs:subPropertyOf flint:fact;
  rdfs:label "game winner" ;
  rdfs:comment "Connects the fact frame of Tic-Tac-Toe with the game winner" ;
  rdfs:domain fact:Frame_TicTacToe ;
  rdfs:range fact:GameWinner.

fact:isPlayedOn rdfs:subPropertyOf flint:fact;
  rdfs:label "is played on" ;
  rdfs:comment "Connects the fact frame of Tic-Tac-Toe with the game board" ;
  rdfs:domain fact:Frame_TicTacToe ;
  rdfs:range fact:GameBoard.
  
fact:isPlayedBy rdfs:subPropertyOf flint:fact;
  rdfs:label "is played by" ;
  rdfs:comment "Connects the fact frame of Tic-Tac-Toe with the game board" ;
  rdfs:domain fact:Frame_TicTacToe ;
  rdfs:range fact:Player.
  
fact:playerTurn rdfs:subPropertyOf flint:fact;
  rdfs:label "player turn" ;
  rdfs:comment "Connects the fact frame of Tic-Tac-Toe with who has the turn" ;
  rdfs:domain fact:Frame_TicTacToe ;
  rdfs:range fact:Player.

fact:opponentOf rdfs:subPropertyOf flint:fact;
  rdfs:label "opponent of" ;
  rdfs:comment "Connects a player and the player's opponent" ;
  rdfs:domain fact:Player ;
  rdfs:range fact:Player.

fact:hasSquare rdfs:subPropertyOf flint:fact;
  rdfs:label "has square" ;
  rdfs:comment "Connects the game board with a square" ;
  rdfs:domain fact:GameBoard ;
  rdfs:range fact:Square.

fact:hasSquareContent rdfs:subPropertyOf flint:fact;
  rdfs:label "has square content" ;
  rdfs:comment "Connects square content with a square" ;
  rdfs:domain fact:Square ;
  rdfs:range fact:SquareContent.


